import { g as a, a as c } from "./functions.7b9d19fa.js";
const h = [
  { type: "lowshelf12", frequency: 30, gain: 0, Q: 0.7, bypass: !1 },
  { type: "peaking12", frequency: 200, gain: 0, Q: 0.7, bypass: !1 },
  { type: "peaking12", frequency: 1e3, gain: 0, Q: 0.7, bypass: !1 },
  { type: "highshelf12", frequency: 5e3, gain: 0, Q: 0.7, bypass: !1 },
  { type: "noop", frequency: 350, gain: 0, Q: 1, bypass: !1 },
  { type: "noop", frequency: 350, gain: 0, Q: 1, bypass: !1 },
  { type: "noop", frequency: 350, gain: 0, Q: 1, bypass: !1 },
  { type: "noop", frequency: 350, gain: 0, Q: 1, bypass: !1 }
];
class g {
  constructor(e, t = h) {
    this.audioCtx = e, this.spec = t, this.filterbank = [], this.input = e.createGain(), this.output = e.createGain(), this.buildFilterChain(t);
  }
  connect(e) {
    this.output.connect(e);
  }
  disconnect(e) {
    this.output.disconnect(e);
  }
  setFilterType(e, t) {
    var n;
    if (t === "noop" && this.spec[e].type !== "noop" && !this.spec[e].bypass ? this.disconnectFilter(e) : t !== "noop" && this.spec[e].type === "noop" && !this.spec[e].bypass && this.connectFilter(e, t), this.spec[e].type = t, t !== "noop" && !this.spec[e].bypass) {
      let i = (n = this.filterbank.find((s) => s.idx === e)) == null ? void 0 : n.filters;
      if (!i)
        throw new Error("Assertion failed: No filters in filterbank");
      for (let s of i)
        s.type = a(t);
      let l = c(t);
      for (; i.length > l; ) {
        let s = i.length - 1, r = i[s], f = i[s - 1], o = this.getNextInChain(e);
        r.disconnect(), f.disconnect(r), f.connect(o), i.splice(s, 1);
      }
      for (; i.length < l; ) {
        let s = this.audioCtx.createBiquadFilter();
        s.type = a(t), s.frequency.value = this.spec[e].frequency, s.Q.value = this.spec[e].Q, s.gain.value = this.spec[e].gain;
        let r = i[i.length - 1], f = this.getNextInChain(e);
        r.disconnect(f), r.connect(s), s.connect(f), i.push(s);
      }
    }
  }
  toggleBypass(e, t) {
    t && !this.spec[e].bypass && this.spec[e].type !== "noop" ? this.disconnectFilter(e) : !t && this.spec[e].bypass && this.spec[e].type !== "noop" && this.connectFilter(e, this.spec[e].type), this.spec[e].bypass = t;
  }
  disconnectFilter(e) {
    var l;
    let t = (l = this.filterbank.find((s) => s.idx === e)) == null ? void 0 : l.filters;
    if (!t)
      throw new Error("Assertion failed: No filters in filterbank when disconnecting filter. Was it connected?");
    let n = this.getPreviousInChain(e), i = this.getNextInChain(e);
    n.disconnect(t[0]), t[t.length - 1].disconnect(i), n.connect(i), this.filterbank = this.filterbank.filter((s) => s.idx !== e);
  }
  connectFilter(e, t) {
    let n = Array.from({ length: c(t) }, () => {
      let s = this.audioCtx.createBiquadFilter();
      return s.type = a(t), s.frequency.value = this.spec[e].frequency, s.Q.value = this.spec[e].Q, s.gain.value = this.spec[e].gain, s;
    }), i = this.getPreviousInChain(e), l = this.getNextInChain(e);
    i.disconnect(l), i.connect(n[0]);
    for (let s = 0; s < n.length - 1; s++)
      n[s].connect(n[s + 1]);
    n[n.length - 1].connect(l), this.filterbank.push({ idx: e, filters: n });
  }
  setFilterFrequency(e, t) {
    this.spec[e].frequency = t;
    let n = this.filterbank.find((i) => i.idx === e);
    if (n)
      for (let i of n.filters)
        i.frequency.value = t;
  }
  setFilterQ(e, t) {
    this.spec[e].Q = t;
    let n = this.filterbank.find((i) => i.idx === e);
    if (n)
      for (let i of n.filters)
        i.Q.value = t;
  }
  setFilterGain(e, t) {
    this.spec[e].gain = t;
    let n = this.filterbank.find((i) => i.idx === e);
    if (n)
      for (let i of n.filters)
        i.gain.value = t;
  }
  getFrequencyResponse(e, t, n, i, l) {
    let s = this.filterbank.find((r) => r.idx === e);
    return s ? (s.filters[t].getFrequencyResponse(n, i, l), !0) : !1;
  }
  buildFilterChain(e) {
    this.filterbank = [];
    for (let t = 0; t < e.length; t++) {
      let n = e[t];
      if (n.type === "noop" || n.bypass)
        continue;
      let i = Array.from({ length: c(n.type) }, () => {
        let l = this.audioCtx.createBiquadFilter();
        return l.type = a(n.type), l.frequency.value = n.frequency, l.Q.value = n.Q, l.gain.value = n.gain, l;
      });
      this.filterbank.push({ idx: t, filters: i });
    }
    if (this.filterbank.length === 0)
      this.input.connect(this.output);
    else
      for (let t = 0; t < this.filterbank.length; t++) {
        let { filters: n } = this.filterbank[t];
        t === 0 ? this.input.connect(n[0]) : this.filterbank[t - 1].filters[this.filterbank[t - 1].filters.length - 1].connect(n[0]);
        for (let i = 0; i < n.length - 1; i++)
          n[i].connect(n[i + 1]);
        t === this.filterbank.length - 1 && n[n.length - 1].connect(this.output);
      }
  }
  getPreviousInChain(e) {
    let t = this.input, n = -1;
    for (let i of this.filterbank)
      i.idx < e && i.idx > n && (t = i.filters[i.filters.length - 1], n = i.idx);
    return t;
  }
  getNextInChain(e) {
    let t = this.output, n = this.spec.length;
    for (let i of this.filterbank)
      i.idx > e && i.idx < n && (t = i.filters[0], n = i.idx);
    return t;
  }
}
export {
  g as WEQ8Runtime
};
