import { LitElement } from "lit";
import { WEQ8Runtime } from "../runtime";
import "./weq8-ui-filter-row";
export declare class WEQ8UIElement extends LitElement {
    static styles: import("lit").CSSResult[];
    runtime?: WEQ8Runtime;
    private analyser?;
    private frequencyResponse?;
    private gridXs;
    private dragStates;
    private analyserCanvas?;
    private frequencyResponseCanvas?;
    updated(changedProperties: Map<string, unknown>): void;
    render(): import("lit-html").TemplateResult<1>;
    private renderGridX;
    private renderGridY;
    private renderFilterHandle;
    private startDraggingFilterHandle;
    private stopDraggingFilterHandle;
    private dragFilterHandle;
    private specUpdate;
}
